=== debian/changelog ===
apparmor (2.7.0~beta1+bzr1774-1) unstable; urgency=low

  * New upstream devel snapshot:
    - drop 0002-lp750381.patch, taken upstream.
    - drop 0004-lp754889.patch, taken upstream.
    - drop 0005-lp761217.patch, taken upstream.
    - drop 0100-manpage-typo.patch, taken upstream.
    - drop 0101-declarations.patch, solved differently upstream.
    - drop 0102-manpage-release-name.patch, taken upstream.
    - drop 0103-kfreebsd-compile.patch, taken upstream.
    - drop define-path-max.patch, taken upstream.
    - drop indep-build.patch, taken upstream.
    - debian/libapparmor1.manpages: add new function man pages.
  * Merge with Ubuntu:
    - drop 0104-python-aa-status.patch, taken upstream.
    - drop 0105-lightdm.patch, taken upstream.
    - drop 0106-lp810270.patch, taken upstream.
    - drop 0107-lp767308.patch, taken upstream.
    - drop 0108-gnome-mimeinfo.patch, taken upstream.
    - drop 0109-add-profile-repo-info.patch, taken upstream.
  * Add af_names-generation.patch to allow arbitrary socket.h file location.

 -- Kees Cook <kees@debian.org>  Wed, 10 Aug 2011 18:12:34 -0700

apparmor (2.6.1-4ubuntu5) oneiric; urgency=low

  * debian/patches/0109-add-profile-repo-info.patch: add a blurb about the
    new profiles repository to aa-genprof, along with a link to the wiki
    page.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 18 Jul 2011 10:49:13 -0400

apparmor (2.6.1-4ubuntu4) oneiric; urgency=low

  * debian/patches/0106-lp810270.patch: updated to use upstream commits

 -- Jamie Strandboge <jamie@ubuntu.com>  Fri, 15 Jul 2011 14:08:38 -0500

apparmor (2.6.1-4ubuntu3) oneiric; urgency=low

  * debian/patches/0106-lp810270.patch: adjustments for /var/run -> /run,
    /var/lock -> /run/lock and /dev/shm -> /run/shm transition (LP: #810270)
  * debian/patches/0107-lp767308.patch: allow read access to
    /usr/local/share/ca-certificates (LP: #767308)
  * debian/patches/0001-add-chromium-browser.patch: updates for newer chromium
    (LP: #776648)
  * debian/patches/0108-gnome-mimeinfo.patch: allow read access to
    /usr/share/gnome/applications/mimeinfo.cache in the gnome abstraction

 -- Jamie Strandboge <jamie@ubuntu.com>  Thu, 14 Jul 2011 09:39:49 -0500

apparmor (2.6.1-4ubuntu2) oneiric; urgency=low

  * debian/patches/0105-lightdm.patch: allow owner read access to
    /var/run/lightdm/authority/[0-9]*

 -- Jamie Strandboge <jamie@ubuntu.com>  Wed, 22 Jun 2011 16:29:11 -0500

apparmor (2.6.1-4ubuntu1) oneiric; urgency=low

  * Get rid of Perl in main AppArmor package so we can remove perl-modules
    from the installation cd:
    - debian/patches/0104-python-aa-status.patch: switch aa-status to
      Python
    - debian/apparmor.*, debian/apparmor-utils.*: move aa-status, symlink
      and manpages to main apparmor package.
    - debian/control: add appropriate Breaks/Replaces/Depends because of
      the file move, add ${python:Depends} to apparmor Depends, add
      apparmor-utils to apparmor Suggests.
    - debian/rules: add apparmor package to dh_python2.
  * debian/lib/apparmor/functions: fix hat separator (LP: #788616)
    - Based on upstream revision 1733

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 01 Jun 2011 11:03:20 -0400

apparmor (2.6.1-4) unstable; urgency=low

  * debian/po: add new translations:
    - zh_CN.po: Simplified Chinese, thanks to Aron Xu (Closes: 624853).
    - da.po: Danish, thanks to Joe Dalton (Closes: 625252).
    - sv.po: Swedish, thanks to Martin Bagge (Closes: 625264).
    - cs.po: Czech, thanks to Michal Šimůnek (Closes: 625465).
    - de.po: German, thanks to Chris Leick (Closes: 625931).
    - nl.po: Dutch, thanks to Jeroen Schot (Closes: 626269).
    - ja.po: Japanese, thanks to Hideki Yamane (Closes: 626803).
    - it.po: Italian, thanks to Dario Santamaria (Closes: 626836).
    - fr.po: French, thanks to Julien Patriarca (Closes: 626903).
    - es.po: Spanish, thanks to Francisco Javier Cuadrado (Closes: 627031).
  * debian/patches/define-path-max.patch: fix Hurd FTBFS.
  * debian/patches/indep-build.patch: allow split indep/arch builds.
  * debian/{control,rules,non-linux}: add fake parser for non-Linux
    builds so that apparmor-utils is installable (Closes: 625977).

 -- Kees Cook <kees@debian.org>  Fri, 27 May 2011 13:51:18 -0700

apparmor (2.6.1-3) unstable; urgency=low

  * debian/control: add sneaky missing Build-Dep on liblocale-gettext-perl
    (fixes FTBFS on some extremely minimal chroots, Closes: 624566).
  * debian/patches/0101-declarations.patch: add missing declarations needed
    for sensitive compilers (fixes FTBFS on mips/mipsel).
  * debian/patches/0102-manpage-release-name.patch: update manpage release
    names to match others.
  * debian/patches/0103-kfreebsd-compile.patch, debian/{control,rules}:
    attempt to build as much as possible (no parser) on non-Linux systems.
  * debian/po/ru.po: add translation, thanks to Yuri Kozlov (Closes: 624741).

 -- Kees Cook <kees@debian.org>  Sun, 01 May 2011 19:29:07 -0700

apparmor (2.6.1-2) unstable; urgency=low

  * debian/copyright: clarify for some full organization names.

 -- Kees Cook <kees@debian.org>  Wed, 27 Apr 2011 10:38:07 -0700

apparmor (2.6.1-1) unstable; urgency=low

  * Initial Debian upload (Closes: 622922).
  * debian/patches/0100-manpage-typo.patch: fix lintian error in manpage.
  * debian/clean: update for Debian build.
  * debian/copyright: rearrange and add a few missing files.
  * debian/source/format, debian/rules: convert to 3.0 quilt format.
  * debian/{rules,apparmor-profiles.postinst}: deal with lack of dh_apparmor.

 -- Kees Cook <kees@debian.org>  Sat, 23 Apr 2011 12:14:55 -0700

apparmor (2.6.1-0ubuntu3) natty; urgency=low

  * debian/patches/0003-add-debian-integration-to-lighttpd.patch: updates for
    lighttpd example profile to work in Debian/Ubuntu (LP: #582814)
  * debian/patches/0004-lp754889.patch: add several image viewers to
    ubuntu-browsers.d/multimedia abstraction (LP: #754889)

